import { ref as O, reactive as te, computed as ve, toRefs as we, defineComponent as ge, onMounted as Pe, resolveComponent as m, openBlock as p, createBlock as v, withCtx as o, createElementVNode as G, renderSlot as A, createVNode as s, unref as e, createElementBlock as N, Fragment as K, renderList as W, mergeProps as B, withModifiers as De, createTextVNode as q, toDisplayString as re, createCommentVNode as z, resolveDirective as Ae, withDirectives as Ce, createSlots as Me, resolveDynamicComponent as Te, normalizeProps as xe, guardReactiveProps as Oe, withKeys as Ue, onBeforeUnmount as $e, nextTick as Le, vShow as Ne, isRef as ze } from "vue";
import { ElMessage as He, ElMessageBox as Se, ElNotification as Ke, ElButton as oe, ElButtonGroup as qe, ElDialog as Ie } from "element-plus";
import { useRoute as je } from "vue-router";
const U = O({
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}), d = O({
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}), _e = O({});
function ne(r) {
  let f;
  try {
    f = Array.isArray(r) ? [] : {}, r === null && (f = null);
  } catch {
    f = {};
  }
  for (const _ in r)
    typeof r[_] == "object" ? f[_] = ne(r[_]) : f[_] = r[_];
  return f;
}
function Ee(...r) {
  function f(a) {
    return typeof a == "object" && Object.prototype.toString.call(a) === "[object Object]";
  }
  let _ = arguments.length, b = arguments[0];
  f(b) || (b = {});
  for (let a = 1; a < _; a++) {
    let C = arguments[a];
    if (f(C))
      for (let D in C)
        D === "__proto__" || b === C[D] || b.hasOwnProperty(D) && (f(C[D]) ? b[D] = Ee(b[D], C[D]) : b[D] = C[D]);
  }
  return b;
}
function We(r, f) {
  let _ = {}, b = Object.getOwnPropertyNames(r), a = Object.getOwnPropertyNames(f);
  return b.length === a.length && b.forEach((C) => {
    r[C] !== f[C] && (_[C] = f[C]);
  }), _;
}
const ae = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Qe(r = { debug: !1 }) {
  const f = te({
    hooks: {}
  });
  return Object.keys(r).forEach((b) => {
    b !== "debug" && (f.hooks[b] = r[b]);
  }), {
    hookHandler: (b, a) => {
      let C = !1;
      try {
        r.debug && (console.group("DeBug\uFF1A", b), console.table(a.Data), console.groupEnd()), C = f.hooks[b](a);
      } catch {
        C = !0;
      }
      return C;
    }
  };
}
let w = {};
const de = O(), Je = (r) => {
  de.value = r.CrudRequest, U.value = Ee(U.value, r), be("\u3010\u521D\u59CB\u5316Options\u3011", r), w = { ...U.value };
}, Ge = (r) => {
  _e.value = r, Xe(_e.value.source), U.value = Ee(U.value, _e.value), be("UseCrudStates\u4F20\u53C2\u3010props\u3011", _e.value), be("\u3010DefParams\u3011", U.value), be("\u3010CrudStates\u3011", d.value);
};
function he() {
  return { ...we(U.value) };
}
function k() {
  return { ...we(d.value) };
}
function ke() {
  return { ...we(_e.value) };
}
const Be = () => {
  const r = _e.value, f = (t) => {
    let n = {};
    return r.rowKey && (n[r.rowKey] = t[r.rowKey]), r.rowKeys && r.rowKeys.forEach((F) => {
      n[F] = t[F];
    }), n;
  }, { hookHandler: _ } = Qe(r.hooks);
  function b() {
    d.value.tableLoading = !0;
    const t = te({ ...d.value.initSearchModel, ...d.value.searchModel });
    for (const n in t)
      typeof t[n] == "string" && (t[n] = t[n].trim(), t[n] === "" && (t[n] = void 0)), t[n] === null && (t[n] = void 0);
    !_(ae.beforeQueryHandler, { CrudState: d.value, Data: t }) || de.value({
      url: r.url,
      name: U.value.ApiName.query,
      data: {
        pagenum: U.value.Page_PageParams.current,
        pagesize: U.value.Page_PageParams.pageSize,
        ...t
      }
    }).then((n) => {
      const { data: F, page: S } = n;
      setTimeout(() => {
        a(F, t), U.value.Page_PageParams.total = S.total, d.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      d.value.tableLoading = !1;
    });
  }
  const a = (t, n) => {
    Object.keys(n).filter((S) => n[S] != null).length == 0 && (d.value.originalData = t), d.value.originalData = ne(t), _(ae.afterQueryHandler, { CrudState: d.value, Data: t }) && (d.value.tableData = ne(t));
  };
  function C() {
    d.value.editModel = ne(d.value.initEditModel);
    const t = te({ ...d.value.editModel });
    !_(ae.beforeAddHandler, { CrudState: d.value, Data: t }) || (d.value.Mode = "add", d.value.DialogVisible = !0);
  }
  const D = (t) => {
    const n = te({
      ...t
    });
    if (!_(ae.beforeEditHandler, { CrudState: d.value, Data: n }))
      return;
    const F = ne(n);
    Object.keys(F).forEach((S) => {
      d.value.editModel[S] = F[S], d.value.editFormValue[S] = F[S];
    }), d.value.Mode = "edit", d.value.DialogVisible = !0;
  }, P = async (t) => {
    !t || await t.validate((n) => {
      if (n) {
        const F = te({
          ...d.value.editModel
        });
        if (!_(ae.beforeSubmitHandler, { CrudState: d.value, Data: F }))
          return;
        d.value.Mode === "add" ? h(F) : E(F);
      }
    });
  }, h = (t) => {
    d.value.submitLoading = !0;
    let n = t;
    t.FormData instanceof FormData && (n = t.FormData), de.value({ url: r.url, name: U.value.ApiName.add, data: n }).then(() => {
      d.value.DialogVisible = !1, me("\u65B0\u589E\u6210\u529F"), b(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  }, E = (t) => {
    d.value.submitLoading = !1;
    let n = t;
    if (t.FormData instanceof FormData)
      n = t.FormData;
    else {
      const F = We(d.value.editModel, n);
      if (JSON.stringify(F) === "{}")
        return d.value.submitLoading = !1, He({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      n = {
        ...f(t),
        ...F
      };
    }
    de.value({ url: r.url, name: U.value.ApiName.edit, data: n }).then(() => {
      d.value.DialogVisible = !1, me("\u7F16\u8F91\u6210\u529F"), b(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: b,
    addRecord: C,
    editRecord: D,
    handleSubmit: P,
    delFlag: (t) => {
      Se.confirm(`\u786E\u5B9A\u8981 \u201C${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          ...f(t),
          deleteFlag: t.deleteFlag == 0 ? 1 : 0
        });
        !_(ae.beforedisabledHandler, { CrudState: d.value, Data: n }) || de.value({
          url: r.url,
          name: U.value.ApiName.deleteFlag,
          data: n
        }).then(() => {
          me(`\u6570\u636E${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), b();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (t) => {
      Se.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          ...f(t)
        });
        !_(ae.beforeDeteleHandler, { CrudState: d.value, Data: n }) || de.value({
          url: r.url,
          name: U.value.ApiName.delete,
          data: n
        }).then(() => {
          me("\u5220\u9664\u6210\u529F"), b();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const t = d.value.multipleSelection.map((n) => n[r.rowKey]);
      Se.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${t.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          [r.rowKey]: t,
          selection: d.value.multipleSelection
        });
        !_(ae.beforeBatchDeteleHandler, { CrudState: d.value, Data: n }) || de.value({
          url: r.url,
          name: U.value.ApiName.remove,
          data: n
        }).then(() => {
          me("\u6279\u91CF\u5220\u9664\u6210\u529F"), d.value.multipleSelection = [], d.value.CompRef.TableRef.clearSelection(), b();
        });
      }).catch(() => {
      });
    }
  };
};
function be(...r) {
  U.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...r);
}
const Xe = (r) => {
  const { filter: f, editor: _, column: b, columns: a } = r;
  d.value.ElementArrs = { filter: {}, editor: {}, column: {}, columns: {} };
  let C = {};
  f.forEach((P) => {
    try {
      C[P] = a[P].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    d.value.ElementArrs.filter[P] = a[P];
  }), d.value.initSearchModel = ne(C), d.value.searchModel = ne(d.value.initSearchModel);
  let D = {};
  _.forEach((P) => {
    try {
      D[P] = a[P].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    d.value.ElementArrs.editor[P] = a[P];
  }), d.value.initEditModel = ne(D), b.forEach((P) => {
    d.value.ElementArrs.column[P] = a[P];
  }), d.value.ElementArrs.columns = a;
};
ve(() => {
  let r = [];
  for (const f in d.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(d.value.ElementArrs.editor, f) && d.value.ElementArrs.editor[f].type === "el-upload" && r.push(f);
  return r;
});
const me = (r, f = "success") => {
  Ke({
    title: r,
    type: f,
    offset: 70,
    duration: 2500
  });
}, Ye = /* @__PURE__ */ ge({
  __name: "crud_SearchForm",
  setup(r) {
    const f = O(), { Form_LabelWidth: _ } = he(), {
      CompRef: b,
      searchModel: a,
      ElementArrs: {
        value: { filter: C }
      }
    } = k();
    Pe(() => {
      b.value.SearchFormRef = f.value;
    });
    const D = (h) => {
      var E, V;
      return h.range ? (E = h.formProps) != null && E.type ? h.formProps.type + "range" : "daterange" : (V = h.formProps) != null && V.type ? h.formProps.type : "date";
    }, P = (h, E, V) => {
      a.value[E] === V ? a.value[E] = void 0 : a.value[E] = h.formProps.options[V].value;
    };
    return (h, E) => {
      const V = m("el-input"), x = m("el-form-item"), $ = m("el-col"), t = m("el-input-number"), n = m("el-option"), F = m("el-select"), S = m("el-date-picker"), L = m("el-time-picker"), ue = m("el-radio"), X = m("el-radio-button"), j = m("el-radio-group"), se = m("el-row"), Y = m("el-form"), Z = m("el-collapse-transition");
      return p(), v(Z, null, {
        default: o(() => [
          G("div", null, [
            A(h.$slots, "search-form", {}, void 0, !0),
            s(Y, {
              ref_key: "SearchFormRef",
              ref: f,
              model: e(a),
              "label-width": e(_)
            }, {
              default: o(() => [
                s(se, null, {
                  default: o(() => [
                    A(h.$slots, "search-form-top", {}, void 0, !0),
                    (p(!0), N(K, null, W(e(C), (u, y) => {
                      var Q;
                      return p(), N(K, null, [
                        u.type === "el-input" ? (p(), v($, {
                          key: 0,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(V, B({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-input-number" ? (p(), v($, {
                          key: 1,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(t, B({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-select" ? (p(), v($, {
                          key: 2,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(F, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, u.formProps), {
                                  default: o(() => [
                                    (p(!0), N(K, null, W(u.formProps.options, (g) => (p(), v(n, {
                                      key: g.value,
                                      label: g.label,
                                      value: g.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" && !D(u).includes("range") ? (p(), v($, {
                          key: 3,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(S, B({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" ? (p(), v($, {
                          key: 4,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(S, B({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, {
                                  type: D(u)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" && !((Q = u.formProps) != null && Q.isRange) && !u.range ? (p(), v($, {
                          key: 5,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(L, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" ? (p(), v($, {
                          key: 6,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(L, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-radio-group" ? (p(), v($, {
                          key: 7,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(x, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(j, B({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g
                                }, u.formProps), {
                                  default: o(() => [
                                    u.formProps.button ? z("", !0) : (p(!0), N(K, { key: 0 }, W(u.formProps.options, (g) => (p(), v(ue, B({
                                      key: g.value,
                                      label: g.value,
                                      onClick: De((ee) => P(u, y, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(re(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    u.formProps.button ? (p(!0), N(K, { key: 1 }, W(u.formProps.options, (g) => (p(), v(X, B({
                                      key: g.value,
                                      label: g.value,
                                      onClick: De((ee) => P(u, y, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(re(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64);
                    }), 256)),
                    A(h.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const Re = (r, f) => {
  const _ = r.__vccOpts || r;
  for (const [b, a] of f)
    _[b] = a;
  return _;
}, Ze = /* @__PURE__ */ Re(Ye, [["__scopeId", "data-v-394e11ba"]]), el = { class: "edit" }, ll = { class: "edit_form" }, ol = /* @__PURE__ */ ge({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(r) {
    const f = O(), { Form_LabelWidth: _ } = he(), {
      CompRef: b,
      editModel: a,
      Mode: C,
      ElementArrs: {
        value: { editor: D }
      },
      uploadFiles: P
    } = k();
    Pe(() => {
      b.value.EditFormRef = f.value;
    });
    const h = ve(() => {
      let t = {};
      return ke().source.value.editor.forEach((n) => {
        typeof D[n].visible == "function" ? D[n].visible(k(), C.value) && (t[n] = D[n]) : t[n] = D[n];
      }), t;
    }), E = ({ showFileList: t }) => {
      if (t)
        return !1;
      if (P.value[0])
        return URL.createObjectURL(P.value[0]);
    }, V = (t) => typeof t.disabled == "function" ? t.disabled(k(), C.value) : !1, x = (t) => {
      let n = { ...t };
      return Object.keys(n).forEach((F) => {
        typeof n[F] == "function" && (n[F] = n[F].bind(this, k()));
      }), n;
    }, $ = (t, n, F) => {
      a.value[n] === F ? a.value[n] = void 0 : a.value[n] = t.formProps.options[F].value;
    };
    return (t, n) => {
      const F = m("el-input"), S = m("el-form-item"), L = m("el-col"), ue = m("el-input-number"), X = m("el-option"), j = m("el-select"), se = m("el-date-picker"), Y = m("el-time-picker"), Z = m("el-cascader"), u = m("el-button"), y = m("el-image"), Q = m("plus"), g = m("el-icon"), ee = m("el-upload"), ie = m("el-radio"), pe = m("el-radio-button"), ce = m("el-radio-group"), R = m("el-row"), T = m("el-form"), M = m("el-scrollbar");
      return p(), N("div", el, [
        s(M, {
          height: r.height,
          "max-height": r.height
        }, {
          default: o(() => [
            G("div", ll, [
              A(t.$slots, "edit-form", { editModel: e(a) }, void 0, !0),
              s(T, {
                ref_key: "EditFormRef",
                ref: f,
                model: e(a),
                "label-width": e(_)
              }, {
                default: o(() => [
                  s(R, null, {
                    default: o(() => [
                      A(t.$slots, "edit-form-top", { editModel: e(a) }, void 0, !0),
                      (p(!0), N(K, null, W(e(h), (l, i) => (p(), N(K, { key: i }, [
                        l.type === "el-input" ? (p(), v(L, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(F, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (p(), v(L, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ue, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (p(), v(L, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(j, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    (p(!0), N(K, null, W(l.formProps.options, (c) => (p(), v(X, {
                                      key: c.value,
                                      label: c.label,
                                      value: c.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (p(), v(L, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(se, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (p(), v(L, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(Y, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (p(), v(L, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(Z, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (p(), v(L, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ee, B({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: i + "UploadRef",
                                  action: ""
                                }, x(l.formProps)), {
                                  default: o(() => {
                                    var c;
                                    return [
                                      ((c = l.formProps) == null ? void 0 : c.listType) !== "picture-card" ? (p(), v(u, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: o(() => [
                                          q(re(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : z("", !0),
                                      l.formProps.listType === "picture-card" && E(l.formProps) ? (p(), v(y, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: E(l.formProps)
                                      }, null, 8, ["src"])) : z("", !0),
                                      l.formProps.listType == "picture-card" && !E(l.formProps) ? (p(), v(g, { key: 2 }, {
                                        default: o(() => [
                                          s(Q)
                                        ]),
                                        _: 1
                                      })) : z("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (p(), v(L, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: i,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ce, B({
                                  modelValue: e(a)[i],
                                  "onUpdate:modelValue": (c) => e(a)[i] = c,
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    l.formProps.button ? z("", !0) : (p(!0), N(K, { key: 0 }, W(l.formProps.options, (c) => (p(), v(ie, B({
                                      key: c.value,
                                      label: c.value,
                                      onClick: De((le) => $(l, i, c.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(re(c.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (p(!0), N(K, { key: 1 }, W(l.formProps.options, (c) => (p(), v(pe, B({
                                      key: c.value,
                                      label: c.value,
                                      onClick: De((le) => $(l, i, c.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(re(c.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64))), 128)),
                      A(t.$slots, "edit-form-bottom", { editModel: e(a) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const al = /* @__PURE__ */ Re(ol, [["__scopeId", "data-v-08532dff"]]), tl = { key: 1 }, nl = /* @__PURE__ */ ge({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(r, { emit: f }) {
    const _ = O(), { Table_isOpenMultipleSelection: b, Table_isOpenIndex: a, Table_isOpenExpand: C, Table_ExpandColumn: D, Table_MenuAlign: P, Table_MenuWidth: h, Page_PageParams: E, Permission: V } = he(), {
      CompRef: x,
      tableData: $,
      tableLoading: t,
      ElementArrs: {
        value: { filter: n, column: F, columns: S }
      },
      searchModel: L,
      multipleSelection: ue
    } = k(), { rowKey: X, keyName: j, Table_Attributes: se } = ke(), { queryRecord: Y, editRecord: Z, delFlag: u, deleteRecord: y } = Be();
    Pe(() => {
      x.value.TableRef = _.value;
    });
    const Q = ve(() => {
      var R, T;
      return (((R = E == null ? void 0 : E.value) == null ? void 0 : R.current) - 1) * ((T = E == null ? void 0 : E.value) == null ? void 0 : T.pageSize) + 1;
    }), g = (R) => {
      ue.value = R;
    }, ee = (R, T, M, l) => {
      T.label && navigator.clipboard.writeText(M.innerText).then(() => {
        He.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, ie = (R, T, M) => {
      M.preventDefault(), f("row-contextmenu", { row: R, column: T, event: M }, k());
    }, pe = (R, T, M) => {
      if (T.formProps) {
        const l = T.formProps.options.findIndex((i) => i.value == R[M]);
        return l === -1 ? R[M] : T.formProps.options[l].label;
      } else
        return R[M];
    }, ce = (R, T) => {
      let M = { ...R };
      return Object.keys(M).forEach((l) => {
        typeof M[l] == "function" && (M[l] = M[l].call(this, k(), T));
      }), M;
    };
    return (R, T) => {
      const M = m("el-empty"), l = m("el-table-column"), i = m("el-descriptions-item"), c = m("el-descriptions"), le = m("el-input"), fe = m("el-button"), Fe = m("el-table"), I = Ae("loading");
      return Ce((p(), v(Fe, B({
        ref_key: "TableRef",
        ref: _,
        data: e($),
        "row-key": e(X),
        height: r.height,
        onCellDblclick: ee,
        onSelectionChange: g,
        onRowContextmenu: ie
      }, e(se)), {
        empty: o(() => [
          s(M, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: o(() => [
          e(b) ? (p(), v(l, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : z("", !0),
          e(C) ? (p(), v(l, {
            key: 1,
            type: "expand",
            width: 55
          }, {
            default: o((H) => [
              s(c, {
                column: e(D),
                border: ""
              }, {
                default: o(() => [
                  (p(!0), N(K, null, W(e(S), (J, ye) => (p(), N(K, { key: ye }, [
                    J.hidden ? z("", !0) : (p(), v(i, {
                      key: 0,
                      label: J.label
                    }, {
                      default: o(() => [
                        q(re(pe(H.row, J, ye)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : z("", !0),
          e(a) ? (p(), v(l, {
            key: 2,
            label: "###",
            width: 55,
            "show-overflow-tooltip": ""
          }, {
            default: o(({ $index: H }) => [
              q(re(e(Q) + H), 1)
            ]),
            _: 1
          })) : z("", !0),
          (p(!0), N(K, null, W(e(F), (H, J) => (p(), v(l, B({
            key: J,
            align: H.align || "left",
            label: H.label,
            prop: J
          }, H.tableProps, { "show-overflow-tooltip": "" }), Me({ _: 2 }, [
            H.columnSlot ? {
              name: "default",
              fn: o((ye) => [
                (p(), v(Te(H.columnSlot.is), xe(Oe(ce(H.columnSlot, ye))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          A(R.$slots, "table-column"),
          s(l, {
            align: e(P) || "left",
            width: e(h)
          }, {
            header: o(() => [
              e(j) ? (p(), v(le, {
                key: 0,
                modelValue: e(L)[e(j)],
                "onUpdate:modelValue": T[0] || (T[0] = (H) => e(L)[e(j)] = H),
                placeholder: e(n)[e(j)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: Ue(e(Y), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (p(), N("span", tl, "\u64CD\u4F5C"))
            ]),
            default: o((H) => [
              A(R.$slots, "menu-top", { scope: H }),
              s(fe, {
                plain: "",
                type: H.row[e(V).deleteFlag] ? "danger" : "success",
                onClick: (J) => e(u)(H.row)
              }, {
                default: o(() => [
                  q(re(H.row[e(V).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                ]),
                _: 2
              }, 1032, ["type", "onClick"]),
              s(fe, {
                plain: "",
                type: "primary",
                icon: "edit",
                onClick: (J) => e(Z)(H.row)
              }, null, 8, ["onClick"]),
              s(fe, {
                plain: "",
                type: "danger",
                icon: "delete",
                onClick: (J) => e(y)(H.row)
              }, null, 8, ["onClick"]),
              A(R.$slots, "menu-bottom", { scope: H })
            ]),
            _: 3
          }, 8, ["align", "width"])
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [I, e(t)]
      ]);
    };
  }
}), rl = /* @__PURE__ */ ge({
  __name: "crud_Pagination",
  setup(r) {
    const { Page_PageSizes: f, Page_PageParams: _, Page_Layout: b, Page_isHideOnSinglePage: a } = he(), { queryRecord: C } = Be(), D = (h) => {
      _.value.pageSize = h, C();
    }, P = (h) => {
      _.value.current = h, _.value.current != null && C();
    };
    return (h, E) => {
      const V = m("el-pagination");
      return p(), v(V, {
        "hide-on-single-page": e(a),
        "current-page": e(_).current,
        "page-size": e(_).pageSize,
        "page-sizes": e(f),
        background: "",
        layout: e(b),
        total: e(_).total,
        onSizeChange: D,
        onCurrentChange: P
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), ul = { style: { padding: "20px", "background-color": "#fff" } }, sl = { class: "button_left" }, dl = /* @__PURE__ */ q(" \u65B0\u589E "), il = /* @__PURE__ */ q(" \u6279\u91CF\u5220\u9664 "), pl = { class: "button_right" }, cl = { style: { display: "flex", "justify-content": "flex-end" } }, fl = /* @__PURE__ */ q("\u53D6\u6D88"), _l = /* @__PURE__ */ q("\u91CD\u7F6E"), ml = /* @__PURE__ */ q("\u63D0\u4EA4"), bl = /* @__PURE__ */ ge({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => w.debug },
    mainMaxHeight: { default: () => w.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => w.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => w.isOpenSearchForm },
    Form_LabelWidth: { default: () => w.Form_LabelWidth },
    Dialog_Width: { default: () => w.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => w.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => w.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => w.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => w.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => w.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => w.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => w.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => w.Table_ExpandColumn },
    Page_PageSizes: { default: () => w.Page_PageSizes },
    Page_PageParams: { default: () => w.Page_PageParams },
    Page_Layout: { default: () => w.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => w.Page_isHideOnSinglePage },
    ApiName: { default: () => w.ApiName },
    Permission: { default: () => w.Permission },
    Permissions: { default: () => w.Permissions }
  },
  emits: ["row-contextmenu"],
  setup(r, { emit: f }) {
    const _ = r, b = je();
    Ge(_);
    const { queryRecord: a, addRecord: C, handleSubmit: D, deleteMulRecord: P } = Be(), { CompRef: h, initSearchModel: E, Mode: V, DialogVisible: x, multipleSelection: $, submitLoading: t, DialogVisibleFooterButton: n } = k(), { isOpenSearchForm: F, isAfterMountQuery: S, Table_isOpenMultipleSelection: L, Dialog_Width: ue, Dialog_isFullscreen: X, Dialog_isCloseOnPressEscape: j, Dialog_isCloseOnClickModal: se, Permission: Y, Permissions: Z } = he();
    if (b.params.data) {
      be("\u8DEF\u7531\u4F20\u53C2\uFF1A", b.params.data);
      let i = b.params.data, c = JSON.parse(i);
      E.value = Ee(E.value, c);
    }
    const u = O(), y = O(), Q = O(), g = O(), ee = O(0), ie = O(0), pe = O(0), ce = O(0);
    Pe(() => {
      h.value.containerDivRef = u.value, h.value.searchDivRef = y.value, h.value.buttonDivRef = Q.value, h.value.paginationDivRef = g.value, ee.value = u.value.offsetHeight - 40, ie.value = h.value.searchDivRef.offsetHeight, pe.value = h.value.buttonDivRef.offsetHeight, ce.value = h.value.paginationDivRef.offsetHeight, S.value && a();
    });
    const R = ve(() => {
      const i = O(ee.value - pe.value - ce.value);
      return F.value ? i.value - ie.value : i.value;
    }), T = ve(() => {
      const i = O(document.documentElement.clientHeight);
      return X.value ? i.value - 54 - 62 - 2 : i.value - 54 - 62 - 2 - i.value * 0.15 - 50;
    }), M = ({ row: i, event: c }, le) => {
      f("row-contextmenu", { row: i, event: c }, le);
    }, l = O(!0);
    return $e(() => {
      l.value = !1, Le(() => {
        l.value = !0;
      });
    }), (i, c) => {
      var fe, Fe;
      const le = Ae("Auth");
      return l.value ? (p(), N("div", {
        key: 0,
        ref_key: "containerDivRef",
        ref: u,
        style: { height: "100%" }
      }, [
        G("div", ul, [
          G("div", {
            ref_key: "searchDivRef",
            ref: y
          }, [
            Ce(s(Ze, null, {
              "search-form": o(() => [
                A(i.$slots, "search-form", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-top": o(() => [
                A(i.$slots, "search-form-top", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-bottom": o(() => [
                A(i.$slots, "search-form-bottom", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [Ne, e(F)]
            ])
          ], 512),
          G("div", {
            ref_key: "buttonDivRef",
            ref: Q,
            class: "buttonDiv"
          }, [
            G("div", sl, [
              Ce((p(), v(e(oe), {
                type: "primary",
                icon: "plus",
                onClick: e(C)
              }, {
                default: o(() => [
                  dl
                ]),
                _: 1
              }, 8, ["onClick"])), [
                [le, { Permissions: e(Z), access: [(fe = e(Y)) == null ? void 0 : fe.add] }]
              ]),
              e(L) ? Ce((p(), v(e(oe), {
                key: 0,
                disabled: e($).length <= 0,
                type: "danger",
                icon: "delete",
                onClick: e(P)
              }, {
                default: o(() => [
                  il
                ]),
                _: 1
              }, 8, ["disabled", "onClick"])), [
                [le, { Permissions: e(Z), access: [(Fe = e(Y)) == null ? void 0 : Fe.remove] }]
              ]) : z("", !0),
              A(i.$slots, "button-left", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            G("div", pl, [
              A(i.$slots, "button-right", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            s(e(qe), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: o(() => [
                s(e(oe), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(a)
                }, null, 8, ["onClick"]),
                s(e(oe), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: c[0] || (c[0] = (I) => e(h).SearchFormRef.resetFields())
                }),
                s(e(oe), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: c[1] || (c[1] = (I) => F.value = !e(F))
                })
              ]),
              _: 1
            })
          ], 512),
          s(nl, {
            height: e(R),
            onRowContextmenu: M
          }, {
            "table-column": o(() => [
              A(i.$slots, "table-column", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-top": o((I) => [
              A(i.$slots, "menu-top", {
                scope: I,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-bottom": o((I) => [
              A(i.$slots, "menu-bottom", {
                scope: I,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          G("div", {
            ref_key: "paginationDivRef",
            ref: g,
            style: { "padding-top": "20px" }
          }, [
            s(rl)
          ], 512),
          s(e(Ie), {
            class: "DialogVisible",
            modelValue: e(x),
            "onUpdate:modelValue": c[5] || (c[5] = (I) => ze(x) ? x.value = I : null),
            title: e(V) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(ue),
            "close-on-press-escape": e(j),
            fullscreen: e(X),
            "close-on-click-modal": e(se)
          }, Me({
            default: o(() => [
              s(al, { height: e(T) }, {
                "edit-form": o(() => [
                  A(i.$slots, "edit-form", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-top": o(() => [
                  A(i.$slots, "edit-form-top", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": o(() => [
                  A(i.$slots, "edit-form-bottom", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(n) ? {
              name: "footer",
              fn: o(() => [
                G("div", cl, [
                  A(i.$slots, "edit-form-footer", {}, void 0, !0),
                  s(e(oe), {
                    onClick: c[2] || (c[2] = (I) => x.value = !1)
                  }, {
                    default: o(() => [
                      fl
                    ]),
                    _: 1
                  }),
                  s(e(oe), {
                    type: "warning",
                    plain: "",
                    onClick: c[3] || (c[3] = (I) => e(h).EditFormRef.resetFields())
                  }, {
                    default: o(() => [
                      _l
                    ]),
                    _: 1
                  }),
                  s(e(oe), {
                    type: "primary",
                    loading: e(t),
                    onClick: c[4] || (c[4] = (I) => e(D)(e(h).EditFormRef))
                  }, {
                    default: o(() => [
                      ml
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512)) : z("", !0);
    };
  }
});
const Ve = /* @__PURE__ */ Re(bl, [["__scopeId", "data-v-639b2373"]]), vl = {
  mounted(r, f, _) {
  }
};
Ve.install = (r) => {
  r.component("CrudEl", Ve), r.directive("Auth", vl);
};
const yl = (r, f) => {
  f ? (f.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Je(f), r.use(Ve)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  Ee as DataMerger,
  ne as DeepClone,
  Je as InitSys,
  yl as createCrudEl,
  ae as hooksName,
  We as isObjEqual,
  Qe as useHooks
};
